function I1to2 = warpUsingH(I1,H)
%Images are stored as I1(Y,X)=[R,G,B]

disp('warpUsingH started...');

numPixX = size(I1,2);
numPixY = size(I1,1);
numChan = size(I1,3);

I1to2 = zeros(numPixY,numPixX,numChan,'uint8');

for i = 1:numPixX
    for j = 1:numPixY
        q = [i;j;1];
        p = H*q;
        p = p/p(3);
        if(p(1)<1 || p(1)>numPixX || p(2)<1 || p(2)>numPixY)
            I1to2(j,i,:) = zeros(1,1,numChan,'uint8');
        else
            %for k = 1:numChan
                %I1to2(j,i,k) = interp2(I1(:,:,k),p(2),p(1));
            %end
            p = round(p);
            I1to2(j,i,:) = I1(p(2),p(1),:);
        end
    end
    
    %Display Progression every 10%
    if(mod(i,round(numPixX/10))==0)
        disp([num2str(round(i/numPixX*100)),'%']);
    end
end

disp('warpUsingH completed');